import random
import pygame
from Image import transformImage
from random import triangular
police = pygame.font.SysFont("Alef", 30)
police2 = pygame.font.SysFont("Alef", 20)

"""
climats = {
    "janvier" : {
        "temp" : [2,7.8],
        "humidité" : [78,90]
    },
    "février" : {
            "temp" : [4.5,11.8],
            "humidité" : [60,85]
        },
        "mars" : {
            "temp" : [3.7,13.7],        
            "humidité" : [45,90]
        },
        "avril" : {
            "temp" : [15.4,4.7],            
            "humidité" : [42,76]
        },
        "mai" : {
            "temp" : [18.1,8.7],            
            "humidité" : [43,80]
        },
        "juin" : {
            "temp" : [24.5,14.6],            
            "humidité" : [60,84]
        },
        "juillet" : {
            "temp" : [24.9,15.5],            
            "humidité" : [45,84]
        },
        "août" : {
            "temp" : [24.6,14.8],            
            "humidité" : [64,81]
        },
        "septembre" : {
            "temp" : [24,14],            
            "humidité" : [58,90]
        },
        "octobre" : {
            "temp" : [18.3,8.6],            
            "humidité" : [70, 89]
        },
        "novembre" : {
            "temp" : [11.3,4.9],
            "humidité" : [75,99]
        },
        "décembre" : {
            "temp" : [10.3,3.8],            
            "humidité" : [77,99]
        }

    }
"""

class Temps:    
    climats = {
        "Automne" : {
            "temp" : [4.8,13.3],            
            "humidité" : [70,95]
            
        },
        "Hiver" : {
            "temp" : [-5,10.3],            
            "humidité" : [50,90]
        },
        "Printemps" : {
            "temp" : [13,27],            
            "humidité" : [40,90]
        },
        "été" : {
            "temp" : [25,40],            
            "humidité" : [40,96]    
        }
    }

    def __init__(self):
        self.ListTemps = ["neige","orage","pluie","ensoleillee","vent","secheresse","canicule","froid","chaud"]

        self.indice = 2
        self.currentSeason = self.getSaisonName(self.indice)
        self.globaltemp = self.tirageTemperature(self.currentSeason)
        self.humidite = self.tirageAuSortChiffreIntervallehumidite(self.currentSeason)
        self.temps = pygame.image.load(self.tempAAfficher(self.currentSeason,self.tirageTemps()))
        self.iconSaison = transformImage(self.temps,200,200)

        self.nextSeason = self.getSaisonName(self.indice+1)
        self.nextglobalTemps = self.tirageTemperature(self.nextSeason)
        self.nexthumidite = self.tirageAuSortChiffreIntervallehumidite(self.nextSeason)
        self.nextTemps = pygame.image.load(self.tempAAfficher(self.nextSeason,self.tirageTemps()))
        self.nexticonSaison = transformImage(self.nextTemps,100,100)

        self.tempsaisonImage = police.render(self.currentSeason +" : "+ str(round(self.globaltemp,1))+" °C",True,(0,0,0))
        
        
        self.tempsaisonImageDeuxPosiiton = police2.render(self.nextSeason +" : "+ str(round(self.nextglobalTemps,1))+" °C",True,(0,0,0))
        for key,value in self.climats.items():
            self.climats.get(key)['image'] = transformImage(pygame.image.load("../assets/Saison/"+key+".png"),400,300)
    
        

    def NextTurn(self):
        #Le next qui devien current
        self.indice += 1
        self.currentSeason = self.nextSeason
        self.globaltemp = self.nextglobalTemps
        self.humidite = self.nexthumidite
        self.temps = self.nextTemps
        self.iconSaison = self.nexticonSaison
        self.tempsaisonImage = police.render(self.currentSeason +" : "+ str(round(self.globaltemp,1))+" °C",True,(0,0,0))

        #Nouveau turn
        self.nextSeason = self.getSaisonName(self.indice+1)
        self.nextglobalTemps = self.tirageTemperature(self.nextSeason)
        self.nexthumidite = self.tirageAuSortChiffreIntervallehumidite(self.nextSeason)
        self.nextTemps = pygame.image.load(self.tempAAfficher(self.currentSeason,self.tirageTemps()))
        self.nexticonSaison = transformImage(self.nextTemps,100,100)
        
        self.tempsaisonImageDeuxPosiiton = police2.render(self.nextSeason +" : "+ str(round(self.nextglobalTemps,1))+" °C",True,(0,0,0))

    def getSaisonName(self,indice:int)->str:
        return list(self.climats.keys())[indice%4]

    def tirageTemperature(self,clef):
        #tirage au sort pour avoir un nombre representatif dans son domaine; par exemple [0,10], la temp sera de 5
        
        intervalle = self.getClimatTemp(clef)
        """
        randomNombre = random.random() * (intervalle[1]-intervalle[0]) + intervalle[0]
        return randomNombre
        """
        return random.triangular(low = intervalle[0],high = intervalle[1])

    def tirageAuSortChiffreIntervallehumidite(self,clef):
        #tirage au sort pour avoir un nombre representatif dans son domaine; par exemple [0,10], la temp sera de 5
        intervalle = self.getClimatHumidite(clef)

        #randomNombre = random.random() * (intervalle[1]-intervalle[0]) + intervalle[0]
        return random.triangular(low = intervalle[0],high = intervalle[1])

    def tirageTemps(self):
        nbrandom = random.randint(0,len(self.ListTemps)-1)
        print("nbrandom"+ str(nbrandom))
        print(self.ListTemps[nbrandom])
        return self.ListTemps[nbrandom]

    def tempAAfficher(self, saison,temps:str)-> str:
        #Determination du temps a afficher

        if saison == "Automne" and temps not in ["secheresse","canicule","chaud"]:
            print("Automne")
            return str("../assets/Temps/"+temps+".png")
        elif saison == "Hiver" and temps not in ["secheresse","canicule","chaud"]:
            print("rentrer hiver")
            return str("../assets/Temps/"+temps+".png")
        elif saison == "Printemps" and temps not in ["secheresse","canicule","neige"]:
            print("Printemps")
            return str("../assets/Temps/"+temps+".png")
        elif saison == "été" and temps not in ["froid","neige"]:
            print("été")
            return str("../assets/Temps/"+temps+".png")
        else:
            return self.tempAAfficher(saison,self.tirageTemps())


    
    def getClimatTemp(self,clef):
        return self.climats[clef]["temp"]

    def getClimatHumidite(self,clef):
        return self.climats[clef]["humidité"]

    def getcurrentSeason(self):
        return self.currentSeason

    def getImageSaison(self):
        return self.climats.get(self.currentSeason).get('image')


    